%Apl binding site code, produces relative repression curves given parameter
%values B, U, F, pR and pL, over a concentration range
function RR = pLMBUFRR(B,U,F,pR,pL)
%B is the specific binding constant 
%U ia the non-specific binding constant,
%F is the cooperation constant
%n is the number of potential Apl binding sites (specifc and non-specific) 
n=11;
N=2^n; %N is the number of states with n sites
W=ones(N,1);%stores weights for 01111111 
Y=ones(N,1);%stores weights for 01101011 
Z=ones(N,1); %stores weights for 01100011 
X=ones(N,1);%stores weights for pL111111
COM1=zeros(N,1); %stores weights when promoter not blocked with Apl
COM2=zeros(N,1);
COM3=zeros(N,1);
COM4=zeros(N,1);
l=0; %pre-determined for loop indexes
k=0;
j=0;
i=0;
y=0;
v=0;
A=state11(n);%this makes A matrix of n*N, where each row is a unique possible state
%concentrations from the data
C_range=[0	369.7264138	432.6990619	457.4216923	530.1959588	573.398359	671.6863441	799.7625176	824.25	915.6314119	1066.004	1233.536	1496.48];
C2_range=[0,369.7264138,432.6990619,457.4216923,530.1959588,573.398359,671.6863441,799.7625176,915.6314119,974.7867153,1133.012705,1184.868403,1436.09962];
On=[3,4,8,9]; %always specific sites
Off=[1,2,10,11]; %non-specific sites
for k=1:length(C_range)
c=C_range(k);
c2=C2_range(k);
    for j=1:N %for each state
       for i=1:4 %for each site always ones, ie sites 3,4 8 and 9
            y=On(i);
            if A(j,y)==1
            W(j)=c*(B+U)*W(j);%01111111
            Y(j)=c*(B+U)*Y(j);%01101011
            Z(j)=c2*(B+U)*Z(j);%01100011
            X(j)=c2*(B+U)*X(j);
            end
        i=i+1;
        end
        for v=1:4 %for sites that are sometimes 1
            z=Off(v);
            if A(j,z)==1
                W(j)=c*U*W(j); %01111111
                Y(j)=c*U*Y(j); %01101011
                Z(j)=c2*U*Z(j); %01100011
                X(j)=c2*U*X(j);
            end
           v=v+1;
        end  
        %sites 5, 6 and 7 are sometimes specific or non-specific
        if A(j,5)==1
            W(j)=c*(B+U)*W(j);
            Y(j)=c*U*Y(j);
            Z(j)=c2*U*Z(j);
            X(j)=c2*(B+U)*X(j);
         end
        if A(j,6)==1  
                W(j)=c*(B+U)*W(j); %01111111
                Y(j)=c*(B+U)*Y(j); %01101011
                Z(j)=c2*U*Z(j);    %01100011
                X(j)=c2*(B+U)*X(j); %pL111111
        end     
        if A(j,7)==1  
                W(j)=c*(B+U)*W(j); %01111111
                Y(j)=c*U*Y(j); %01101011
                Z(j)=c2*U*Z(j);  %01100011
                X(j)=c2*(B+U)*X(j);%pL111111
        end 
       %cooperation between adjacent sites      
        for l=1:10
            if A(j,l)==1 && A(j,l)==A(j,l+1)
            W(j)=F*W(j);
            Y(j)=F*Y(j);
            Z(j)=F*Z(j);
            X(j)=F*X(j);
            end
        l=l+1;
        end
        %the states where RNAP competes with Apl
        if  A(j,9)==0 &&  A(j,10)==0 && A(j,11)==0  
            W(j)=(1+pL)*W(j);
            Y(j)=(1+pL)*Y(j);
            Z(j)=(1+pL)*Z(j);
            COM4(j)=X(j);
            X(j)=(1+pL)*X(j);
        end
        if  A(j,2)==0 && A(j,3)==0 && A(j,4)==0 && A(j,1)==0
           COM1(j)=W(j);
            W(j)=(1+pR)*W(j);
            COM2(j)=Y(j);
            Y(j)=(1+pR)*Y(j);
            COM3(j)=Z(j);
            Z(j)=(1+pR)*Z(j);
        end
       
        
    j=j+1;
    end
    %normalisation factors for pR and pL
M1=(pR+1+pL+pL*pR)/(pR+pL*pR); 
M2=(pL+1)/pL;
RR(k,1)=(M1*pR*sum(COM1))/sum(W); %the states where RNAP binds
RR(k,2)=(M1*pR*sum(COM2))/sum(Y);
RR(k,3)=(M1*pR*sum(COM3))/sum(Z);
RR(k,4)=(M2*pL*sum(COM4))/sum(X);
k=k+1;  
W=ones(N,1);
Y=ones(N,1);
Z=ones(N,1);
X=ones(N,1);
COM1=zeros(N,1);
COM2=zeros(N,1);
COM3=zeros(N,1);
COM4=zeros(N,1);
end

%relative repression data
RRD1=[1.0000,    0.8950 ,   0.8905,    0.8713,    0.8394,    0.8444 ,   0.8036 ,   0.6929,  0.7253,    0.5447,    0.5442 ,   0.4323  ,  0.4179];
RRD2=[1.0000,    1.0,    0.999999,    0.99999,    0.9999,    0.999,    0.99,    0.985, 0.98,    0.9636,    0.8568,    0.6918,    0.6004];
RRD3=[1.0000    0.9769    0.9748    1.0200    0.9889    1.0027    0.9466    0.9975    0.9781    1.0093    0.8250    0.8005    0.6089];
RRD4=[ 1.0000    1.0479    1.0261    0.9814    0.9336    0.8663    0.6703    0.5245    0.4146    0.3716    0.2971    0.3190    0.2053];

ERR1=[0	0.021231673	0.038355751	0.038143835	0.038679874	0.034011769	0.032710259	0.03893732	0.014816434	0.039052882	0.036675488	0.015693029	0.012070855];
ERR2=[0	0.022474446	0.043923292	0.046718604	0.03996993	0.045324679	0.034497922	0.029801977	0.038621026	0.035644013	0.06580542	0.089602671	0.061385295];
ERR3=[0	0.050440781	0.064050778	0.045078073	0.054948928	0.060486231	0.065746666	0.042214754	0.063188947	0.056415454	0.065236964	0.050506985	0.037158544];
ERR4=[0	0.019552999	0.025326897	0.021820856	0.017141867	0.018555108	0.024721902	0.026628458	0.02116404	0.01721286	0.016077611	0.020345892	0.015857981];
ERR5 =zeros((length(C_range)),1); 

%plot to show how the current parameters look against the data
subplot(1,4,1)
 hold on
   errorbar(C_range, RR(:,1),ERR5, 'r-*');
   errorbar(C_range, RRD1,ERR1, 'b-');
   hold off
   title('01111111')
 subplot(1,4,2)
 hold on
   errorbar(C_range, RR(:,2),ERR5, 'r-*');
  errorbar(C_range, RRD2,ERR2, 'b-');
   hold off
   title('01101011')
 subplot(1,4,3)
 hold on
   errorbar(C2_range, RR(:,3),ERR5, 'r-*');
   errorbar(C2_range, RRD3,ERR3, 'b-');
   hold off
   title('01100011')   
subplot(1,4,4)
 hold on
   errorbar(C2_range, RR(:,4),ERR5, 'r-*');
   errorbar(C2_range, RRD4,ERR4, 'b-');
   hold off
   title('01111111pL')
